-- 
-- Animallight LS17
-- version: 1.2
-- date: 25.10.2015
-- last update: 26.10.2016
-- author: [FSM]Chefkoch
-- hp: http://fsm-team.de
-- 
-- Keine Veränderung ohne meine Erlaubnis!
-- No modification without	my permission!
--
-- History:
-- v1:		project started
-- v1.1:	added switchsound
-- v1.2:	converted to LS17

Animallight = {};

function Animallight.prerequisitesPresent(specializations)
    return true;
end;

function Animallight:load(savegame)
	self.setAnimallight = SpecializationUtil.callSpecializationsFunction("setAnimallight");
	self.cl = {};
	self.cl.rl = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.Animallight#realLight"));
	self.cl.co = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.Animallight#corona"));
	self.cl.turnOn = false;
	self.cl.isOn = false;
	self.cl.active = false;
	setVisibility( self.cl.rl, false );
	setVisibility( self.cl.co, false );
	
	AnimallightSoundFile = Utils.getFilename("Sounds/blinktick.wav", self.baseDirectory);
	self.AnimallightSoundId = createSample("AnimallightSound");
	loadSample(self.AnimallightSoundId, AnimallightSoundFile, false);
	self.AnimallightSoundPlaying = false;
	
end;

function Animallight:delete()
end;

function Animallight:readStream(streamId, connection)
	local state = streamReadBool(streamId);
	self:setAnimallight(state, true);
end;

function Animallight:writeStream(streamId, connection)
	streamWriteBool(streamId, self.cl.turnOn);
end;

function Animallight:readUpdateStream(streamId, timestamp, connection)
end;

function Animallight:writeUpdateStream(streamId, connection, dirtyMask)
end;

function Animallight:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Animallight:keyEvent(unicode, sym, modifier, isDown)
end;

function Animallight:update(dt)
	if self:getIsActive() then
		if self.isClient and self:getIsActiveForInput(false) and not self:hasInputConflictWithSelection() then
			if InputBinding.hasEvent(InputBinding.SWITHANIMALLIGHT) then
				self:setAnimallight(not self.cl.turnOn);
				playSample(self.AnimallightSoundId,1,0.5,0);
			end;
		end;
	end;
	
	local realLightsActive = false;
	realLightsActive = self:getIsActiveForLights();
	
	if (self.cl.turnOn == true and self.cl.isOn == false) or (self.cl.active ~= realLightsActive) then
		if self.cl.rl ~= nil then
			if realLightsActive then
				setVisibility( self.cl.rl, true );
			else
				setVisibility( self.cl.rl, false );
			end
		end;
		if self.cl.co ~= nil then
			setVisibility( self.cl.co, true );			
		end;
		self.cl.active = realLightsActive;
		self.cl.isOn = true;
	elseif (self.cl.turnOn == false and self.cl.isOn == true) then
		if self.cl.rl ~= nil then
			setVisibility( self.cl.rl, false );
		end;
		if self.cl.be ~= nil then
			setVisibility( self.cl.be, false );
		end;
		if self.cl.co ~= nil then
			setVisibility( self.cl.co, false );		
		end;
		self.cl.isOn = false;
	end;
end;

function Animallight:updateTick(dt)

end;

function Animallight:draw()
	if g_currentMission.controlledVehicle ~= nil then
		g_currentMission:addHelpButtonText(g_i18n:getText("ANIMALLIGHTONOFF"), InputBinding.SWITHANIMALLIGHT);
	end;
end;

function Animallight:onLeave()

end;

function Animallight:onEnter()

end;

function Animallight:setAnimallight(state, noEventSend)
	SetAnimallightEvent.sendEvent(self, state, noEventSend);
	self.cl.turnOn = state;
end;
	
	
	
--
--
--
--
--
SetAnimallightEvent = {};
SetAnimallightEvent_mt = Class(SetAnimallightEvent, Event);

InitEventClass(SetAnimallightEvent, "SetAnimallightEvent");

function SetAnimallightEvent:emptyNew()
    local self = Event:new(SetAnimallightEvent_mt);
    self.className="SetAnimallightEvent";
    return self;
end;

function SetAnimallightEvent:new(object, state)
    local self = SetAnimallightEvent:emptyNew()
    self.object = object;
	self.state = state;
    return self;
end;

function SetAnimallightEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
    self.object = networkGetObject(id);
	self.state = streamReadBool(streamId);
    self:run(connection);
end;

function SetAnimallightEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteBool(streamId, self.state);
end;

function SetAnimallightEvent:run(connection)
    self.object:setAnimallight(self.state, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(SetAnimallightEvent:new(self.object, self.state), nil, connection, self.object);
    end;
end;

function SetAnimallightEvent.sendEvent(vehicle, state, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(SetAnimallightEvent:new(vehicle, state), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(SetAnimallightEvent:new(vehicle, state));
		end;
	end;
end;

